/*
Fallen Star Super Sonic
By JosephLol and the Game
Sonic And The Fallen Star by StarDrop
codes: Reverie Super Sonic
*/

//Code is now Better and returned back the Jump Thok and OVA Bounce Abilities 
//to make Super NSonic more and MORE Better

freeslot(
"sfx_spdash")
sfxinfo[sfx_spdash].caption = "Super Dash"

local holdingforward

addHook("PlayerThink",  function(p)
    -- Only Sonic can be Super Sonic
    if not (p.mo and p.mo.valid and (p.mo.skin == "nsonic") /*and p.hyper.capable == true*/)
        return
    end

    -- Only Super people can be Super Sonic
    if not (p.powers[pw_super])
        -- Take your old ability back, normie, we're done here
        if p.eggoldability != nil
            p.charability = p.eggoldability
            p.eggoldability = nil
        end
        -- Non-super people can't be super-flying
        p.eggsuperflying = false
        return
    end
  
    -- Not not Sonic, not not Super, must be Super Sonic!
    -- Play that sick tune (actually don't, the music gets played in a different lua lmao)
    -- Can't go flying if you're in a minecart or a zoom tube
    if p.mo.state == S_PLAY_RIDE or p.powers[pw_carry] == CR_ZOOMTUBE
        return
    end
   
    -- Definitely flying, so initialise/confirm flying-related variables
    p.eggsuperflying = $ or false  -- Boolean for whether Hyper Sonic is flying
    p.eggflystart = $ or false -- Boolean for whether Hyper Sonic just started flying
    p.eggflyboost = $ or false  -- Boolean for whether Hyper Sonic can boost this tic
	p.boostnumer = $ or false -- Boolean for if Hyper Sonic can nuke enemies
    p.eggboostcost = 5  -- How many rings it costs to boost
    p.eggmaxvert = 22*FRACUNIT  -- Maximum vertical flying speed in either direction
    p.eggoldability = $ or CA_JUMPTHOK -- IM FRICKING SMART!
   
    -- If you still have a jump ability, take it away and remember what it was
    if p.eggsuperflying == true
        p.charability = CA_NONE
	else
		p.charability = p.eggoldability
    end
   
    -- You stop flying when you touch the ground
    if P_IsObjectOnGround(p.mo)
        p.eggsuperflying = false
    else
    -- Prevent rolling when holding spin and touching ground while flying.
        if p.eggsuperflying == true
			p.pflags = $ | PF_THOKKED
		end
    end
   
    -- If you're not flying right now, we're done here.
    if not p.eggsuperflying
        return
    end

    -- Gravity doesn't apply when you're flying
    p.mo.momz = $-P_GetMobjGravity(p.mo)
   
	p.cantrick = false
    -- You can't fall when you're flying
    if p.mo.state == S_PLAY_FALL or p.mo.state == S_PLAY_SPRING or p.mo.state == S_PLAY_ROLL or p.mo.state == S_PLAY_JUMP
        p.mo.state = S_PLAY_FLOAT
    end
   
    -- You're not jumping or spinning when you're flying
	p.pflags = $ & ~PF_JUMPED & ~PF_SPINNING
   
    -- You have to let go of jump after you start floating before you can ascend
    if not (p.cmd.buttons & BT_SPIN)
        p.eggflystart = false
    end
	
	--Prevent stored momentum when initiating hover
	if p.eggflystart == true --and p.eggflymode == 1 
		P_SetObjectMomZ(p.mo, 0*FRACUNIT, false)
	end
   
    -- You have to let go of either jump or spin after boosting before you can boost again
        p.eggflyboost = true
    
   
    -- If you're holding jump and not spin, accelerate up
    if (p.cmd.buttons & BT_JUMP) and not (p.cmd.buttons & BT_USE) and not p.eggflystart or (p.cmd.buttons & BT_JUMP) and not (p.cmd.buttons & BT_USE) --and p.eggflymode == 2
        if not ((p.cmd.buttons & BT_CUSTOM1) and (p.eggc1helper == false))
			P_SetObjectMomZ(p.mo, 1*FRACUNIT, true) -- Accelerate up
		end
    end
   
    -- If you're holding spin and not jump, accelerate down
    if (p.cmd.buttons & BT_USE) and not (p.cmd.buttons & BT_JUMP)
		if not ((p.cmd.buttons & BT_CUSTOM1) and (p.eggc1helper == false))
			if p.eggflystart == false
				P_SetObjectMomZ(p.mo, -1*FRACUNIT, true)
			end
		end
    end
   
    -- Cap the max flying speed at both ends
    p.mo.momz = max(min(p.eggmaxvert, p.mo.momz), 0-p.eggmaxvert)
   
    -- If you're holding neither, come to a halt
    if not (p.cmd.buttons & BT_JUMP) and not (p.cmd.buttons & BT_USE)
        p.mo.momz = abs($)>FRACUNIT and $*9/10 or 0
    end
end)

//C2 Binding because i need to return OVA Bounce Attack
addHook("PlayerThink", function(p)
    if (p.mo.skin == "nsonic") and p.mo and p.mo.valid
		if (p.cmd.buttons & BT_CUSTOM1) //Button Here
			if p.powers[pw_super] and not p.flybutton and not p.eggsuperflying
			p.eggsuperflying = true
			p.eggflystart = true
			p.mo.state = S_PLAY_FLOAT
			return true
		end
		//Local Unholded Varible
		p.flybutton = true
		else
		p.flybutton = false
		end
		return false
	end
end)

//stolen code from EX Movesets, but i made it
//SATFS Nova Sonic's Dash
addHook("PlayerThink", function(player)
	local mo = player.mo
	if not (mo and mo.valid and mo.skin == "nsonic") return false end
		if player.eggsuperflying or (mo.state == S_PLAY_FLOAT or mo.state == S_PLAY_FLOAT_RUN)
		
		if player.safsnovasonictrailtimer == nil
			player.safsnovasonictrailtimer = 0
		end
		
		if player.safsnovasoniccircletimer == nil
			player.safsnovasoniccircletimer = 0
		end
		//Fallen star Dash Ghosts
		if player.safsnovasonictrailtimer > 0
			player.safsnovasonictrailtimer = $ - 1
			local SATFSNovasonicGhost = P_SpawnGhostMobj(mo)
			SATFSNovasonicGhost.color = mo.color
			SATFSNovasonicGhost.colorized = true
			SATFSNovasonicGhost.rollangle = mo.rollangle
		end
		if player.safsnovasoniccircletimer > 0
			player.safsnovasoniccircletimer = $ - 1
			if not (leveltime % 5)
			local dashcircle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_THOK)
			dashcircle.state = S_FACESTABBERSPEAR
			dashcircle.color = SKINCOLOR_WHITE
			dashcircle.angle = player.drawangle+ANGLE_90
			dashcircle.scale = player.mo.scale/2+FRACUNIT/4
			dashcircle.fuse = 8
			dashcircle.colorized = true
			dashcircle.blendmode = AST_ADD
			end
		end

		if ((player.cmd.buttons & BT_CUSTOM1) and not player.dashbutton)
				// Dash Forwards
				if player.cmd.forwardmove or player.cmd.sidemove
				P_InstaThrust(mo,mo.angle,FixedMul(90*FRACUNIT,mo.scale))
				player.safsnovasoniccircletimer = 10 //add the circles
				player.safsnovasonictrailtimer = 5
				end
				
				// Dash Upwards
				if (player.cmd.buttons & BT_JUMP) and not (player.cmd.buttons & BT_USE)
					P_SetObjectMomZ(mo, 50*FRACUNIT, true) -- Accelerate/Dash up
				end
				
				// Dash Downwards
				if (player.cmd.buttons & BT_USE) and not (player.cmd.buttons & BT_JUMP)
					P_SetObjectMomZ(mo, -50*FRACUNIT, true) -- Accelerate/Dash down
				end
				
				S_StartSound(mo, sfx_zoom)
			if in2d
				P_InstaThrust(mo, mo.angle, FixedHypot(mo.momx, mo.momy))
			else
				P_InstaThrust(mo, player.cmd.angleturn << 16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove*FRACUNIT), FixedHypot(mo.momx, mo.momy)) // hi Rumia
			end
		end
		if (player.cmd.buttons & BT_CUSTOM1)
			player.dashbutton = true
		else
			player.dashbutton = false
		end
	end
end)
addHook("PlayerThink", function(player)
	if player.mo.skin == "nsonic"
		if player.powers[pw_super] 
			if (player.mo.state == S_PLAY_WALK) and P_IsObjectOnGround(player.mo)
				player.mo.spriteyoffset = FRACUNIT*3 + (3 * cos(ANG10*leveltime))
			else
				player.mo.spriteyoffset = 0
				player.mo.spritexoffset = 0
			end
		else
			player.mo.spriteyoffset = 0
			player.mo.spritexoffset = 0
		end
	end
end)