//SUPER SPARKS LOL
freeslot("SPR_SUSK",
	     "S_SUPERSPARK",
	     "MT_SUPERSPARKLES")

states[S_SUPERSPARK] = {
       sprite = SPR_SUSK,
	   frame = FF_FULLBRIGHT|FF_ANIMATE|A,
	   var1 = 10,
	   var2 = 3
}
mobjinfo[MT_SUPERSPARKLES] = {
         spawnstate = S_SUPERSPARK,
         flags = MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_NOCLIPHEIGHT,
}
//ova sonic bounce state made by neo
freeslot("S_OVA_BOUNCE")
states[S_OVA_BOUNCE] = {SPR_PLAY, SPR2_GLID|FF_ANIMATE, 20, nil, 2, 1, S_PLAY_JUMP}
//sanic bullets
freeslot("SPR_GBUL", "S_GUNBULLET", "MT_GUNBULLET", "sfx_gunsnc")
mobjinfo[MT_GUNBULLET].speed = 99*FRACUNIT

states[S_GUNBULLET] = {
        sprite = SPR_GBUL,
        frame = A,
        tics = -1,
        action = A_ShootBullet
}

mobjinfo[MT_GUNBULLET] = {
	spawnstate = S_GUNBULLET,
	spawnhealth = 1,
	height = 1*FRACUNIT,
	radius = 1*FRACUNIT,
	speed = 100*FRACUNIT,
	flags = MF_MISSILE|MF_NOBLOCKMAP|MF_SOLID|MF_SHOOTABLE
}
//ex dash
local function SafeFreeslot(...)
	for _, item in ipairs({...})
		if rawget(_G, item) == nil
			freeslot(item)
		end
	end
end

SafeFreeslot(
	"MT_NINSTASHIELD",
	"S_NINSTASHIELD",
	"S_NINSTASHIELD1A",
	"S_NINSTASHIELD1B",
	"S_NINSTASHIELD2A",
	"S_NINSTASHIELD2B",
	"S_NINSTASHIELD3A",
	"S_NINSTASHIELD3B",
	"S_NINSTASHIELD4A",
	"S_NINSTASHIELD4B",
	"S_NINSTASHIELD5A",
	"S_NINSTASHIELD5B",
	"S_NINSTASHIELD6A",
	"S_NINSTASHIELD6B",
	"SPR_TWSP"
)

mobjinfo[MT_NINSTASHIELD] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_NINSTASHIELD,
	radius = 48*FRACUNIT,
	height = 48*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
}

states[S_NINSTASHIELD] = {SPR_NULL, 0, 1, A_CapeChase, 0, 0, S_NINSTASHIELD1A}
states[S_NINSTASHIELD1A] = {SPR_TWSP, 0|FF_FULLBRIGHT, 1, A_CapeChase, 0, 0, S_NINSTASHIELD1B}
states[S_NINSTASHIELD1B] = {SPR_NULL, 0, 1, A_CapeChase, 0, 0, S_NINSTASHIELD2A}
states[S_NINSTASHIELD2A] = {SPR_TWSP, 1|FF_FULLBRIGHT, 1, A_CapeChase, 0, 0, S_NINSTASHIELD2B}
states[S_NINSTASHIELD2B] = {SPR_NULL, 0, 1, A_CapeChase, 0, 0, S_NINSTASHIELD3A}
states[S_NINSTASHIELD3A] = {SPR_TWSP, 2|FF_FULLBRIGHT, 1, A_CapeChase, 0, 0, S_NINSTASHIELD3B}
states[S_NINSTASHIELD3B] = {SPR_NULL, 0, 1, A_CapeChase, 0, 0, S_NINSTASHIELD4A}
states[S_NINSTASHIELD4A] = {SPR_TWSP, 3|FF_FULLBRIGHT, 1, A_CapeChase, 0, 0, S_NINSTASHIELD4B}
states[S_NINSTASHIELD4B] = {SPR_NULL, 0, 1, A_CapeChase, 0, 0, S_NINSTASHIELD5A}
states[S_NINSTASHIELD5A] = {SPR_TWSP, 4|FF_FULLBRIGHT, 1, A_CapeChase, 0, 0, S_NINSTASHIELD5B}
states[S_NINSTASHIELD5B] = {SPR_NULL, 0, 1, A_CapeChase, 0, 0, S_NINSTASHIELD6A}
states[S_NINSTASHIELD6A] = {SPR_TWSP, 5|FF_FULLBRIGHT, 1, A_CapeChase, 0, 0, S_NINSTASHIELD6B}
states[S_NINSTASHIELD6B] = {SPR_NULL, 0, 1, A_CapeChase, 0, 0, S_NULL}
//exdash sound
freeslot("sfx_dashex")
sfxinfo[sfx_dashex].caption = "DashEX"
//neon sonic & neon tails swap
freeslot("sfx_budswp")
sfxinfo[sfx_budswp].caption = "Swap"
//fly drop sound
freeslot("sfx_curlt")
sfxinfo[sfx_curlt].caption = "flycurl"
//neon tails flydrop sound
freeslot("sfx_trcul")
sfxinfo[sfx_trcul].caption = "Re-Curl"
//exdash sound
freeslot("sfx_advswi")
sfxinfo[sfx_advswi].caption = "Swiming"
//tail hit sound
freeslot("sfx_tailh")
sfxinfo[sfx_tailh].caption = "Tail Hit"
//advance climbing
freeslot("sfx_advcli")
sfxinfo[sfx_advcli].caption = "Climbing"
//rebound dash pack
freeslot("sfx_airdsh","sfx_bounc1","sfx_bounc2")
sfxinfo[sfx_airdsh].caption = "Dash"
sfxinfo[sfx_bounc1].caption = "Rebound"
sfxinfo[sfx_bounc2].caption = "Heavy Rebound"
//neon knux stomp land
freeslot("sfx_stomp","sfx_land")
sfxinfo[sfx_stomp].caption = "StompLand"
sfxinfo[sfx_stomp].caption = "Land"
freeslot("MT_FIRESONIC_AURA1","MT_FIRESONIC_AURA2")
//better transformation emeralds
freeslot(
"MT_TRANSFORMGEM1",
"MT_TRANSFORMGEM2",
"MT_TRANSFORMGEM3",
"MT_TRANSFORMGEM4",
"MT_TRANSFORMGEM5",
"MT_TRANSFORMGEM6",
"MT_TRANSFORMGEM7",
"S_TRANSFORMGEM1",
"S_TRANSFORMGEM2",
"S_TRANSFORMGEM3",
"S_TRANSFORMGEM4",
"S_TRANSFORMGEM5",
"S_TRANSFORMGEM6",
"S_TRANSFORMGEM7",
"SPR_TRGE"
)

mobjinfo[MT_TRANSFORMGEM1] = {
        doomednum = -1,
        spawnstate = S_TRANSFORMGEM1,
        spawnhealth = 1000,
        reactiontime = TICRATE,
        speed = 0,
        radius = 16*FRACUNIT,
        height = 32*FRACUNIT,
        flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT,
}

mobjinfo[MT_TRANSFORMGEM2] = {
        doomednum = -1,
        spawnstate = S_TRANSFORMGEM2,
        spawnhealth = 1000,
        reactiontime = TICRATE,
        speed = 0,
        radius = 16*FRACUNIT,
        height = 32*FRACUNIT,
        flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT,
}

mobjinfo[MT_TRANSFORMGEM3] = {
        doomednum = -1,
        spawnstate = S_TRANSFORMGEM3,
        spawnhealth = 1000,
        reactiontime = TICRATE,
        speed = 0,
        radius = 16*FRACUNIT,
        height = 32*FRACUNIT,
        flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT,
}

mobjinfo[MT_TRANSFORMGEM4] = {
        doomednum = -1,
        spawnstate = S_TRANSFORMGEM4,
        spawnhealth = 1000,
        reactiontime = TICRATE,
        speed = 0,
        radius = 16*FRACUNIT,
        height = 32*FRACUNIT,
        flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT,
}

mobjinfo[MT_TRANSFORMGEM5] = {
        doomednum = -1,
        spawnstate = S_TRANSFORMGEM5,
        spawnhealth = 1000,
        reactiontime = TICRATE,
        speed = 0,
        radius = 16*FRACUNIT,
        height = 32*FRACUNIT,
        flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT,
}

mobjinfo[MT_TRANSFORMGEM6] = {
        doomednum = -1,
        spawnstate = S_TRANSFORMGEM6,
        spawnhealth = 1000,
        reactiontime = TICRATE,
        speed = 0,
        radius = 16*FRACUNIT,
        height = 32*FRACUNIT,
        flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT,
}

mobjinfo[MT_TRANSFORMGEM7] = {
        doomednum = -1,
        spawnstate = S_TRANSFORMGEM7,
        spawnhealth = 1000,
        reactiontime = TICRATE,
        speed = 0,
        radius = 16*FRACUNIT,
        height = 32*FRACUNIT,
        flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT,
}

states[S_TRANSFORMGEM1] = {
	sprite = SPR_TRGE,
	frame = FF_FULLBRIGHT|A,
	tics = -1,
	nextstate = S_TRANSFORMGEM1
}

states[S_TRANSFORMGEM2] = {
	sprite = SPR_TRGE,
	frame = FF_FULLBRIGHT|B,
	tics = -1,
	nextstate = S_TRANSFORMGEM2
}

states[S_TRANSFORMGEM3] = {
	sprite = SPR_TRGE,
	frame = FF_FULLBRIGHT|C,
	tics = -1,
	nextstate = S_TRANSFORMGEM3
}

states[S_TRANSFORMGEM4] = {
	sprite = SPR_TRGE,
	frame = FF_FULLBRIGHT|D,
	tics = -1,
	nextstate = S_TRANSFORMGEM4
}

states[S_TRANSFORMGEM5] = {
	sprite = SPR_TRGE,
	frame = FF_FULLBRIGHT|E,
	tics = -1,
	nextstate = S_TRANSFORMGEM5
}

states[S_TRANSFORMGEM6] = {
	sprite = SPR_TRGE,
	frame = FF_FULLBRIGHT|F,
	tics = -1,
	nextstate = S_TRANSFORMGEM6
}

states[S_TRANSFORMGEM7] = {
	sprite = SPR_TRGE,
	frame = FF_FULLBRIGHT|G,
	tics = -1,
	nextstate = S_TRANSFORMGEM7
}
//effect
rawset(_G, "ChrispySonic_SpawnDustRing", function(mo, speed, thrust, alwaysabove)
	local momz = mo.momz
	if alwaysabove
		momz = -P_MobjFlip(mo)*abs($)
	end
	if abs(momz) < mo.scale
		momz = $ < 0 and -mo.scale or mo.scale
	end
		
	local forwardangle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
	local sideangle = forwardangle + ANGLE_90
	local vangle = R_PointToAngle2(0, 0, FixedHypot(mo.momx, mo.momy), momz)
	
	local cosine = cos(vangle)
	local sine = sin(vangle)
	
	local radius = FixedDiv(mo.height, mo.scale) >> 1
	local xspawn = -FixedMul(FixedMul(cos(forwardangle), cosine), radius)
	local yspawn = -FixedMul(FixedMul(sin(forwardangle), cosine), radius)
	local zspawn = -FixedMul(sine, radius)
	
	local hthrust = 0
	local vthrust = 0
	if thrust
		hthrust = FixedMul(thrust, cosine)
		vthrust = FixedMul(thrust, sine)
	end
	
	cosine = FixedMul($, speed)
	sine = FixedMul($, speed)
	
	for i = 1, 16
		local dust = P_SpawnMobjFromMobj(mo, xspawn, yspawn, radius, mo.eflags & (MFE_UNDERWATER | MFE_TOUCHWATER) and MT_MEDIUMBUBBLE or MT_DUST)
		
		local a = i*ANGLE_22h + forwardangle
		
		local forwardthrust = FixedMul(cos(a), sine)
		local sidethrust = FixedMul(sin(a), speed)
		local zthrust = FixedMul(cosine, cos(a))
		
		dust.z = $ + zspawn
		
		P_Thrust(dust, forwardangle, forwardthrust - hthrust)
		P_Thrust(dust, sideangle, sidethrust)
		dust.momz = -zthrust - vthrust
		
		dust.fuse = TICRATE/4
		dust.destscale = mo.scale/8
	end
end)